<!DOCTYPE html>
<html>
  <head>
    <meta content="text/html;charset=utf-8" http-equiv="Content-Type"/>
  </head>
  <body>
    <canvas id="canvas" width="500" height="600"></canvas>

    <script type="module">
      let state = { requestId: null, t0: null };
      async function run() {
        draw_initial_text();
        function start() {
          state.requestId = requestAnimationFrame(
            (t) => {state.t0 = t; state.requestId = requestAnimationFrame((t) => step(t));}
          );
        }
        function draw_initial_text() {
          const canvas = document.getElementById("canvas");
          const ctx = canvas.getContext("2d");
          ctx.font = "50px serif";
          ctx.fillText("Press to start", 10, 60);
        }
        function animation(t) {
          const canvas = document.getElementById("canvas");
          const ctx = canvas.getContext("2d");
          ctx.font = "50px serif";
          ctx.clearRect(0, 0, canvas.width, canvas.height);
          ctx.fillText(t.toString(), 10, 110);
        }
        function step(t) {
          animation(t);
          state.t0 = t;
          state.requestId = requestAnimationFrame((t) => step(t));
        }
        function stop() {
          cancelAnimationFrame(state.requestId);
          state.requestId = null;
          draw_initial_text();
        }
        function toggleRun() {
          if(state.requestId === null) start();
          else stop();
        }
        const canvas = document.getElementById("canvas");
        canvas.onclick = toggleRun;
      }
      run();
    </script>
  </body>
</html>
